/*
<This program is a text editor ebable of transcription on text file.>
<Ce programme est un éditeur de texte capable de chiffrement sur des fichier texte.>
Copyright (C) 2008 Keven Chaussé
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef HEADER_DECRYPTEUR
#define HEADER_DECRYPTEUR

#include <QtGui>
#include "ui_decrypteur.h"
#include "FenCryptographe.h"

class Decrypteur : public QWidget, private Ui::Decrypteur
{
    Q_OBJECT

	public:

		Decrypteur(QString *texte, FenCryptographe *parent); // Constructeur principal

    private:

         double indiceCoincidence();
            void analyseFrequence();
            void analyseKasiski();
            int compteLettreAZaz();


    private slots:

        void analyserdocument();
        void calcul();
        void rotX();
        void calculerCle();


	private:

        QString *m_texte;
        QString *m_texteWait;
        QString m_texteOriginal;
        int alphabet[26];
        FenCryptographe *m_parent;
        QStandardItemModel *modelFrequence;
        QStandardItemModel *modelKasiski;
};

#endif
